input bool AlertPopup = true;
input bool Sound = true;
input bool Email = false;
input bool Mobile = false;
input double UpThreshold = 30.0;
input double DownThreshold = 70.0;
input string IndicatorName = "RSI";

datetime dtLastTime = 0;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
{

   double dIndicatorCurrent = 0.0;
   double dIndicatorPrevious = 0.0;
   string strAlertMessage = "";
   
   // Indicator value for Index 0
   dIndicatorCurrent = iRSI(Symbol(),Period(),14,PRICE_CLOSE,0);  
   
   // Indicator value for Index 1
   dIndicatorPrevious = iRSI(Symbol(),Period(),14,PRICE_CLOSE,1); 
   
   /// Process for UP signal
   
   if (dIndicatorCurrent>UpThreshold && dIndicatorPrevious<UpThreshold && dtLastTime!=Time[0])
   {
      dtLastTime = Time[0];
      
      strAlertMessage = StringConcatenate("Alert: ",Symbol(),"_",PeriodToString(Period())," ",IndicatorName," UP");
      
      if (AlertPopup) 
         Alert(strAlertMessage);
      if (Sound)
         PlaySound("alert.wav");
      if (Email)
         SendMail(strAlertMessage,
                  "Current Price "+DoubleToStr(Close[0],Digits)+
                  "\nTime: " + TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS));
      if (Mobile)
         SendNotification(strAlertMessage);            
   }
   
   /// Process for DOWN signal
   
   if (dIndicatorCurrent<DownThreshold && dIndicatorPrevious>DownThreshold && dtLastTime!=Time[0])
   {
      dtLastTime = Time[0];
      
      strAlertMessage = StringConcatenate("Alert: ",Symbol(),"_",PeriodToString(Period())," ",IndicatorName," DOWN");
      
      if (AlertPopup) 
         Alert(strAlertMessage);
      if (Sound)
         PlaySound("alert.wav");
      if (Email)
         SendMail(strAlertMessage,
                  "Current Price "+DoubleToStr(Close[0],Digits)+
                  "\n" + IndicatorName + " Value: " + DoubleToStr(dIndicatorCurrent,2) +
                  "\nTime: " + TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS));
      if (Mobile)
         SendNotification(strAlertMessage);            
  }
   
}

string PeriodToString (int imin)
{

   string strprd;

   switch (imin)
   {

   case (1):  
   strprd="M1"; 
   break;
   case (2):  
   strprd="M2"; 
   break;
   case (3):  
   strprd="M3"; 
   break;
   case (5):  
   strprd="M5"; 
   break;
   case (15):  
   strprd="M15"; 
   break;
   case (30):  
   strprd="M30"; 
   break;
   case (60):  
   strprd="H1"; 
   break;
   case (60*4):  
   strprd="H4"; 
   break;
   case (60*24):  
   strprd="D1"; 
   break;
   case (60*24*7):  
   strprd="W1"; 
   break;
   }

   return (strprd);

}
