

#property indicator_chart_window

#property indicator_buffers 3

#property indicator_color1 Aqua
#property indicator_width1 3
#property indicator_color2 Blue
#property indicator_width2 2
#property indicator_color3 Red
#property indicator_width3 2


//+------------------------------------------------------------------+


extern double ATR_Factor = 2.5;
extern int MA_Period = 50;
int ATR = 14;

//+------------------------------------------------------------------+

double bufferLadder[], bufferUp[], bufferDn[];
double bufferDirection[];

//+------------------------------------------------------------------+

int init()
{
   
   IndicatorBuffers(4);
   
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, bufferLadder);
   SetIndexStyle(1, DRAW_LINE);
   SetIndexBuffer(1, bufferUp);
   SetIndexStyle(2, DRAW_LINE);
   SetIndexBuffer(2, bufferDn);
   SetIndexBuffer(3, bufferDirection);
   
   return(0);

}

//+------------------------------------------------------------------+

int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+

int start()
{
   double thisCCI;
   double dAtr=0.0;
   
   int limit, shift;
   int counted_bars=IndicatorCounted();
   //---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   

   for (shift=limit-1; shift >= 0; shift--)
   {
      thisCCI = iCCI(NULL, 0, MA_Period, PRICE_TYPICAL, shift);
      dAtr = iATR(NULL, 0, ATR, shift);
      
     
      
      bufferDirection[shift]=0.0;
 

      if (thisCCI >= 0)
      {
         bufferLadder[shift] = Low[shift] - dAtr * ATR_Factor;
         if (bufferLadder[shift] < bufferLadder[shift + 1])
            bufferLadder[shift] = bufferLadder[shift + 1];
       
      }
      else
      {
            bufferLadder[shift] = High[shift] + dAtr * ATR_Factor;
            if (bufferLadder[shift] > bufferLadder[shift + 1])
               bufferLadder[shift] = bufferLadder[shift + 1];
               
      }
            

      if (bufferLadder[shift]>bufferLadder[shift+1]) bufferDirection[shift] = 1.0;
      if (bufferLadder[shift]<bufferLadder[shift+1]) bufferDirection[shift] = -1.0;    
      if (bufferLadder[shift]==bufferLadder[shift+1]) bufferDirection[shift] = bufferDirection[shift+1];        
      
      if (bufferDirection[shift]>0.0) bufferUp[shift]=bufferLadder[shift]-Point*2;
      if (bufferDirection[shift]<0.0) bufferDn[shift]=bufferLadder[shift]+Point*2;
      
   }
   
   return(0);
   
}


