#include <stdlib.mqh>



extern int HourStart = 0;
extern int HourEnd = 24;
extern double ATR_Factor = 2.5;
extern int MA_Period = 20; 
extern bool EmailAlert = true;
extern bool MobileAlert = false; 



datetime lastTime=0;


int iTotalSymbol = 11;  

int iDigit[11];
 
string strSymbol[11]={"SPX500","US30","GER30","JPN225","HKG33",
      "EURUSD","GBPUSD","AUDUSD","USDJPY","USOil","XAUUSD"};
                          
bool bTrendAlertTriggered[11]; 
                                  
   


int init()
  {


   for (int i=0; i< iTotalSymbol; i++)
   {
   
   iDigit[i] = MarketInfo(strSymbol[i], MODE_DIGITS);
   bTrendAlertTriggered[i] = false;
   
   }
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   
   
   
   double indexCurrent, indexPrev;
   double dLastDayClose, dUpDnPercent, dPriceCurrent;
   int i;
   
   
      
   if ( TimeHour(Time[0]) < HourStart || TimeHour(Time[0])>= HourEnd ) return (0);
 
   if( lastTime != Time[0] )
   {  
      for (i=0;i<iTotalSymbol;i++)
      {
      
      bTrendAlertTriggered[i] = false; 
      
      }
      
      lastTime = Time[0];
   }
   
   
   for (i=0;i<iTotalSymbol;i++)
   {

   RefreshRates();
    
   indexCurrent = iCustom(strSymbol[i],Period(),"SuperLadder",ATR_Factor,MA_Period,3,1);
   indexPrev = iCustom(strSymbol[i],Period(),"SuperLadder",ATR_Factor,MA_Period,3,2);
   
   if ( indexCurrent != indexPrev && !bTrendAlertTriggered[i] )
         
       {
        
         dLastDayClose = iClose(strSymbol[i],PERIOD_D1,1);
         dPriceCurrent = iClose(strSymbol[i],Period(), 0);
         dUpDnPercent = NormalizeDouble( (dPriceCurrent - dLastDayClose)/dLastDayClose * 100.0, 2);
   
        if (indexCurrent > 0.0)
        {
          OutputMessage(strSymbol[i], "UP", Period(),  DoubleToStr(dPriceCurrent, iDigit[i]),
          DoubleToStr(dLastDayClose, iDigit[i]), DoubleToStr(dUpDnPercent,2));
        }
        
        if (indexCurrent < 0.0)
        {
          OutputMessage(strSymbol[i], "DOWN", Period(),  DoubleToStr(dPriceCurrent, iDigit[i]), 
          DoubleToStr(dLastDayClose, iDigit[i]), DoubleToStr(dUpDnPercent,2));
        }
        
        bTrendAlertTriggered[i] = true;
           
        lastTime = Time[0];
      }
         
   }      
    
  
         
   
//----

   return(0);
  }
//+------------------------------------------------------------------+



 int OutputMessage(string strSym, string strDirection, int iPeriod,  string strPrice,
                     string strLastDayClose, string strUpDnPercent )
 {
 
  
          if (MobileAlert){  
          SendNotification("Trend Alert - "+strSym+ " " + strDirection + PeriodToString(iPeriod) + " " + strPrice );
          }
          if (EmailAlert) {
          SendMail("Trend Alert - " + strSym+ " " + strDirection + " " + PeriodToString(iPeriod) + " " + strPrice,
                  strSym + "_" + PeriodToString(iPeriod) + ": "+strDirection+"\nCurrent Price: " + strPrice 
                  + "\nTime: " + TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS)
                  + "\nLast Day Close: " + strLastDayClose
                  + "\nChange: " + strUpDnPercent + "%");
                  }
       
}

  
 

  
string PeriodToString (int imin)
{

   string strprd;

   switch (imin)
   {

   case (1):  
   strprd="M1"; 
   break;
   case (2):  
   strprd="M2"; 
   break;
   case (3):  
   strprd="M3"; 
   break;
   case (5):  
   strprd="M5"; 
   break;
   case (15):  
   strprd="M15"; 
   break;
   case (30):  
   strprd="M30"; 
   break;
   case (60):  
   strprd="H1"; 
   break;
   case (60*4):  
   strprd="H4"; 
   break;
   case (60*24):  
   strprd="D1"; 
   break;
   case (60*24*7):  
   strprd="W1"; 
   break;
   }

   return (strprd);

}